# coding: utf-8

# flake8: noqa
"""
    Invoicetronic API

    The [Invoicetronic API][2] is a RESTful service that allows you to send and receive invoices through the Italian [Servizio di Interscambio (SDI)][1], or Interchange Service. The API is designed to be simple and easy to use, abstracting away SDI complexity while providing complete control over the invoice send/receive process. It provides advanced features as encryption at rest, multi-language pre-flight invoice validation, multiple upload formats, webhooks, event logging, client SDKs, and CLI tools.  For more information, see  [Invoicetronic website][2]  [1]: https://www.fatturapa.gov.it/it/sistemainterscambio/cose-il-sdi/ [2]: https://invoicetronic.com/

    The version of the OpenAPI document: 1
    Contact: info@invoicetronic.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from invoicetronic_sdk.models.allegati import Allegati
from invoicetronic_sdk.models.altri_dati_gestionali import AltriDatiGestionali
from invoicetronic_sdk.models.anagrafica import Anagrafica
from invoicetronic_sdk.models.cedente_prestatore import CedentePrestatore
from invoicetronic_sdk.models.cessionario_committente import CessionarioCommittente
from invoicetronic_sdk.models.codice_articolo import CodiceArticolo
from invoicetronic_sdk.models.company import Company
from invoicetronic_sdk.models.contatti import Contatti
from invoicetronic_sdk.models.contatti_trasmittente import ContattiTrasmittente
from invoicetronic_sdk.models.dati_anagrafici import DatiAnagrafici
from invoicetronic_sdk.models.dati_anagrafici_cedente_prestatore import DatiAnagraficiCedentePrestatore
from invoicetronic_sdk.models.dati_anagrafici_cessionario_committente import DatiAnagraficiCessionarioCommittente
from invoicetronic_sdk.models.dati_anagrafici_vettore import DatiAnagraficiVettore
from invoicetronic_sdk.models.dati_beni_servizi import DatiBeniServizi
from invoicetronic_sdk.models.dati_bollo import DatiBollo
from invoicetronic_sdk.models.dati_cassa_previdenziale import DatiCassaPrevidenziale
from invoicetronic_sdk.models.dati_contratto import DatiContratto
from invoicetronic_sdk.models.dati_convenzione import DatiConvenzione
from invoicetronic_sdk.models.dati_ddt import DatiDDT
from invoicetronic_sdk.models.dati_fatture_collegate import DatiFattureCollegate
from invoicetronic_sdk.models.dati_generali import DatiGenerali
from invoicetronic_sdk.models.dati_generali_documento import DatiGeneraliDocumento
from invoicetronic_sdk.models.dati_ordine_acquisto import DatiOrdineAcquisto
from invoicetronic_sdk.models.dati_pagamento import DatiPagamento
from invoicetronic_sdk.models.dati_ricezione import DatiRicezione
from invoicetronic_sdk.models.dati_riepilogo import DatiRiepilogo
from invoicetronic_sdk.models.dati_ritenuta import DatiRitenuta
from invoicetronic_sdk.models.dati_sal import DatiSAL
from invoicetronic_sdk.models.dati_trasmissione import DatiTrasmissione
from invoicetronic_sdk.models.dati_trasporto import DatiTrasporto
from invoicetronic_sdk.models.dati_veicoli import DatiVeicoli
from invoicetronic_sdk.models.dettaglio_linee import DettaglioLinee
from invoicetronic_sdk.models.dettaglio_pagamento import DettaglioPagamento
from invoicetronic_sdk.models.document_data import DocumentData
from invoicetronic_sdk.models.error import Error
from invoicetronic_sdk.models.event import Event
from invoicetronic_sdk.models.fattura_elettronica_body import FatturaElettronicaBody
from invoicetronic_sdk.models.fattura_elettronica_header import FatturaElettronicaHeader
from invoicetronic_sdk.models.fattura_ordinaria import FatturaOrdinaria
from invoicetronic_sdk.models.fattura_principale import FatturaPrincipale
from invoicetronic_sdk.models.id_fiscale_iva import IdFiscaleIVA
from invoicetronic_sdk.models.id_trasmittente import IdTrasmittente
from invoicetronic_sdk.models.indirizzo_resa import IndirizzoResa
from invoicetronic_sdk.models.iscrizione_rea import IscrizioneREA
from invoicetronic_sdk.models.problem_details import ProblemDetails
from invoicetronic_sdk.models.problem_http_result import ProblemHttpResult
from invoicetronic_sdk.models.rappresentante_fiscale import RappresentanteFiscale
from invoicetronic_sdk.models.rappresentante_fiscale_cessionario_committente import RappresentanteFiscaleCessionarioCommittente
from invoicetronic_sdk.models.receive import Receive
from invoicetronic_sdk.models.sconto_maggiorazione import ScontoMaggiorazione
from invoicetronic_sdk.models.sede_cedente_prestatore import SedeCedentePrestatore
from invoicetronic_sdk.models.sede_cessionario_committente import SedeCessionarioCommittente
from invoicetronic_sdk.models.send import Send
from invoicetronic_sdk.models.send_reduced import SendReduced
from invoicetronic_sdk.models.stabile_organizzazione import StabileOrganizzazione
from invoicetronic_sdk.models.status import Status
from invoicetronic_sdk.models.terzo_intermediario_o_soggetto_emittente import TerzoIntermediarioOSoggettoEmittente
from invoicetronic_sdk.models.update import Update
from invoicetronic_sdk.models.web_hook import WebHook
from invoicetronic_sdk.models.web_hook_history import WebHookHistory
