# coding: utf-8

"""
    Invoicetronic API

    The [Invoicetronic API][2] is a RESTful service that allows you to send and receive invoices through the Italian [Servizio di Interscambio (SDI)][1], or Interchange Service. The API is designed to be simple and easy to use, abstracting away SDI complexity while providing complete control over the invoice send/receive process. It provides advanced features as encryption at rest, multi-language pre-flight invoice validation, multiple upload formats, webhooks, event logging, client SDKs, and CLI tools.  For more information, see  [Invoicetronic website][2]  [1]: https://www.fatturapa.gov.it/it/sistemainterscambio/cose-il-sdi/ [2]: https://invoicetronic.com/

    The version of the OpenAPI document: 1
    Contact: info@invoicetronic.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from invoicetronic_sdk.models.contatti_trasmittente import ContattiTrasmittente
from invoicetronic_sdk.models.id_trasmittente import IdTrasmittente
from typing import Optional, Set
from typing_extensions import Self

class DatiTrasmissione(BaseModel):
    """
    DatiTrasmissione
    """ # noqa: E501
    id_trasmittente: Optional[IdTrasmittente] = None
    progressivo_invio: Optional[StrictStr] = None
    formato_trasmissione: Optional[StrictStr] = None
    codice_destinatario: Optional[StrictStr] = None
    contatti_trasmittente: Optional[ContattiTrasmittente] = None
    pec_destinatario: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id_trasmittente", "progressivo_invio", "formato_trasmissione", "codice_destinatario", "contatti_trasmittente", "pec_destinatario"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatiTrasmissione from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of id_trasmittente
        if self.id_trasmittente:
            _dict['id_trasmittente'] = self.id_trasmittente.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contatti_trasmittente
        if self.contatti_trasmittente:
            _dict['contatti_trasmittente'] = self.contatti_trasmittente.to_dict()
        # set to None if progressivo_invio (nullable) is None
        # and model_fields_set contains the field
        if self.progressivo_invio is None and "progressivo_invio" in self.model_fields_set:
            _dict['progressivo_invio'] = None

        # set to None if formato_trasmissione (nullable) is None
        # and model_fields_set contains the field
        if self.formato_trasmissione is None and "formato_trasmissione" in self.model_fields_set:
            _dict['formato_trasmissione'] = None

        # set to None if codice_destinatario (nullable) is None
        # and model_fields_set contains the field
        if self.codice_destinatario is None and "codice_destinatario" in self.model_fields_set:
            _dict['codice_destinatario'] = None

        # set to None if pec_destinatario (nullable) is None
        # and model_fields_set contains the field
        if self.pec_destinatario is None and "pec_destinatario" in self.model_fields_set:
            _dict['pec_destinatario'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatiTrasmissione from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id_trasmittente": IdTrasmittente.from_dict(obj["id_trasmittente"]) if obj.get("id_trasmittente") is not None else None,
            "progressivo_invio": obj.get("progressivo_invio"),
            "formato_trasmissione": obj.get("formato_trasmissione"),
            "codice_destinatario": obj.get("codice_destinatario"),
            "contatti_trasmittente": ContattiTrasmittente.from_dict(obj["contatti_trasmittente"]) if obj.get("contatti_trasmittente") is not None else None,
            "pec_destinatario": obj.get("pec_destinatario")
        })
        return _obj


